 float t=0.5; // parameter for displaying a point (red dot) on the curve
 boolean showVertexIds=true, showVertices=true;
 
 void myActions() { // actions to be executed at each frame
    if ((mousePressed)&&(keyPressed)) dragPolygon();  

     // rename points
     pt A=P[0], M=P[1], C=P[2];
     
     // compute derived points and vectors
     pt B=A(A,M); 
     vec V=V(A,M); 
     vec G=S(2,V(M,C));
     
    // Show user-editable input points with their names and the edge (P,Q)
    stroke(grey); fill(grey); 
    showPoints(5); 
    A.showLabel("A",S(15,U(V(C,A))));  
    M.showLabel("M",S(15,U(V(B,M)))); 
    C.showLabel("C",S(15,U(V(A,C))));
    show(P[3],P[4]);
    P[3].showLabel("P",S(15,R(U(V(P[3],P[4])))));  
    P[4].showLabel("Q",S(15,R(U(V(P[3],P[4])))));  

    // show construced points   
    noStroke(); fill(green);  
    B.show(3); B.showLabel("B",S(15,U(V(M,B)))); 
    
    // show hat
    noFill(); stroke(green); strokeWeight(2); show(A,B); show(B,C);

  
    // paint subdivided hats as filled triangles
    fill(cyan); noStroke();
    subdivide(A,B,C,3);
    
    // draw curve using de Casteljau's evaluation
    noFill(); strokeWeight(2); stroke(orange); drawQuadraticBezierFromHat(A,B,C,60);
 
     
    // plot parabola as points using loop with additions only
    noFill();  strokeWeight(2); stroke(blue); plotParabola(A,V,G,30);
    
    // Compute and show intersections with edge
    fill(magenta); stroke(dmagenta); showIntersections(A,B,C,P[3],P[4]); 
   
    // draw V and G scaled down
    fill(red); stroke(red); strokeWeight(1);
    arrow(M,S(.125,G),"G/8"); 
    arrow(A,S(.25,V),"V/4"); 
 
   };

pt parabola(pt A, pt B, pt C, float t) {return L(A,t,C); };  // *** uses de Casteljau alg to evaluate parabola P(t) from its control hat

void drawQuadraticBezierFromHat(pt A, pt B, pt C, int n) {beginShape(); for(float t=0; t<=1; t+=1./n) parabola(A,B,C,t).v(); C.v(); endShape();}

void plotParabola(pt A, vec V, vec G, int n) { // *** computes increments and draws n points along parabola computing each one from the previous one through vector additions only
  pt P=P(A);
  vec eV=S(1./n,V);
  beginShape(POINTS); 
  P.v();
  for(int i=0; i<n; i++) {
    P.addVec(eV);
    P.v();
    }
  endShape();}
  
void showIntersections (pt A, pt B, pt C, pt P, pt Q) { // *** computes and draws as crosses the intersections of the parabola (A,B,C) and edge(P,Q)
  pt X=A(P,Q); cross(X,6);
  }

void subdivide(pt A, pt B, pt C, int r) {  // *** performs a recursive subdivision of the hat and stops after r recusions
  show(A,B,C); 
  }

